class codes:
    def ff():
        string = '''
import sys
sys.setrecursionlimit(60)

def first(string):
    print("string"+string)
    first_ = set()
    if string in non_terminals:
        alternatives = productions_dict[string]
        for alternative in alternatives:
            first_2 = first(alternative)
            first_ = first_ | first_2
    elif string in terminals:
        first_ = {string}
    elif string=='' or string=='@':
        first_ = {'@'}
    else:
        print("inside else")
        first_2 = first(string[0])
        if '@' in first_2:
            i = 1
            while '@' in first_2:
                first_ = first_ | (first_2 - {'@'})
                if string[i:] in terminals:
                    first_ = first_ | {string[i:]}
                    break
                elif string[i:] == '':
                    first_ = first_ | {'@'}
                    break
                first_2 = first(string[i:])
                first_ = first_ | first_2 - {'@'}
                i += 1
        else:
            first_ = first_ | first_2

    
    return  first_

def follow(nT):
    follow_ = set()
    prods = productions_dict.items()
    if nT==starting_symbol:
        follow_ = follow_ | {'$'}
    for nt,rhs in prods:
        for alt in rhs:
            for char in alt:
                if char==nT:
                    following_str = alt[alt.index(char) + 1:]
                    if following_str=='':
                        if nt==nT:
                            continue
                        else:
                            follow_ = follow_ | follow(nt)
                    else:
                        follow_2 = first(following_str)
                        if '@' in follow_2:
                            follow_ = follow_ | follow_2-{'@'}
                            follow_ = follow_ | follow(nt)
                        else:
                            follow_ = follow_ | follow_2
    return follow_

no_of_terminals=int(input("Enter no. of terminals: "))
terminals = []
print("Enter the terminals :")
for _ in range(no_of_terminals):
    terminals.append(input())
no_of_non_terminals=int(input("Enter no. of non terminals: "))
non_terminals = []
print("Enter the non terminals :")
for _ in range(no_of_non_terminals):
    non_terminals.append(input())
starting_symbol = input("Enter the starting symbol: ")
no_of_productions = int(input("Enter no of productions: "))
productions = []
print("Enter the productions:")
for _ in range(no_of_productions):
    productions.append(input())
productions_dict = {}
for nT in non_terminals:
    productions_dict[nT] = []
for production in productions:
    nonterm_to_prod = production.split("->")
    alternatives = nonterm_to_prod[1].split("/")
    for alternative in alternatives:
        productions_dict[nonterm_to_prod[0]].append(alternative)
FIRST = {}
FOLLOW = {}
print(terminals)
print(non_terminals)
print(starting_symbol)
print(productions)
print(productions_dict)
for non_terminal in non_terminals:
    FIRST[non_terminal] = set()
for non_terminal in non_terminals:
    FOLLOW[non_terminal] = set()
for non_terminal in non_terminals:
    FIRST[non_terminal] = FIRST[non_terminal] | first(non_terminal)
FOLLOW[starting_symbol] = FOLLOW[starting_symbol] | {'$'}
for non_terminal in non_terminals:
    FOLLOW[non_terminal] = FOLLOW[non_terminal] | follow(non_terminal)
print("{: ^20}{: ^20}{: ^20}".format('Non Terminals','First','Follow'))
print(FIRST)
print(FOLLOW)
for non_terminal in non_terminals:
    print("{: ^20}{: ^20}{: ^20}".format(non_terminal,str(FIRST[non_terminal]),str(FOLLOW[non_terminal])))

        '''
        print(string)

    def lexical():
        string = '''import re

tokens = []

string = ''
public class AddTwoNumbers {
    public static void main ( String [ ] args ) {
        int num1 = 5, num2 = 15, sum;
        sum = num1 + num2;
        System.out.println ( "Sum=" + sum ) ;
    }
}
''

for word in string.split():
    if word in ['String', 'int', 'boolean','char','byte','short','long','float','double']:
        tokens.append(['Datatype', word])
    elif word in ['public','private','protected','static','final','abstract','switch','case','strictfp','import','void','class']:
        tokens.append(['Keyword', word])
    elif word in '*-/+%=':
        tokens.append(['OPERATOR', word])
    elif re.match("[a-z]", word) or re.match("[A-Z]", word):
        if word[len(word) - 1] == ';': 
            tokens.append(["INTEGER", word[:-1]])
            tokens.append(['SEPERATOR', ';'])
        else:
            tokens.append(['IDENTIFIER', word])
    elif re.match('"[^"]*"', word):
        tokens.append(['LITERAL', word])
    elif re.match("[0-9]", word):
        if word[len(word) - 1] == ',': 
            tokens.append(["INTEGER", word[:-1]])
            tokens.append(['SEPERATOR', ','])
        else:
            tokens.append(["INTEGER", word])
    elif word in ['(',')','{','}','[',']',',',':',';','"']:    
        tokens.append(['DELIMITER', word])

for token in tokens:
    print(token)'''
        print(string)

    def PP():
        string = '''
        import java.util.*;

class PredictiveParser {
    public static void main(String args[]) {
        String var = "EFT", ter = "i+()$", table[][] = { { "TF", "-", "TF", "-", "-" }, { "-", "+TF", "-", "e", "e" },
                { "i", "-", "(E)", "-", "-" } }, ip1 = "i+i$", value;
        int i, j;
        char ip2[] = new char[10], c1, c2;
        ip2 = ip1.toCharArray();
        Stack ip = new Stack();
        for (i = ip2.length - 1; i >= 0; i--) {
            ip.push("" + ip2[i]);
        }
        Stack stack = new Stack();
        stack.push("$");
        stack.push(var.charAt(0));
        System.out.print("\nPredictive Parser / LL(1) Parser Table : \n\n\t ");
        for (i = 0; i < ter.length(); i++)
            System.out.print(ter.charAt(i) + "\t\t");
        System.out.println("\n\t----------------------------------");
        for (i = 0; i < var.length(); i++) {
            System.out.print("\n" + var.charAt(i) + " |\t");
            for (j = 0; j < ter.length(); j++)
                System.out.print(table[i][j] + "\t\t");
        }
        System.out.printf("\n%-20s %-20s\n\n", "\n\nSTACK", "INPUT");
        while (true) {
            for (i = 0; i < stack.size(); i++)
                System.out.print(stack.get(i) + " ");
            if (stack.size() > 3)
                System.out.print("\t");
            else
                System.out.printf("\t\t");
            for (i = ip.size() - 1; i >= 0; i--)
                System.out.print(ip.get(i) + " ");
            System.out.println();
            c1 = stack.peek().toString().charAt(0);
            c2 = ip.peek().toString().charAt(0);
            if ((c1 == c2 && c2 == '$') || (c1 == 'e' && c2 == '$')) {
                System.out.printf("%-20s\n", "Accept!");
                break;
            } else if (c1 == c2 && c2 != '$') {
                try {
                    stack.pop();
                    ip.pop();
                } catch (EmptyStackException e) {
                }
            } else if (table[var.indexOf(c1)][ter.indexOf(c2)] != "-") {
                try {
                    stack.pop();
                } catch (EmptyStackException e) {
                }
                value = table[var.indexOf(c1)][ter.indexOf(c2)];
                for (i = (value.length()) - 1; i >= 0; i--)
                    stack.push("" + (value.charAt(i)));
            } else {
                System.out.println("Error");
                break;
            }
        }
    }
}       
        '''
        print(string)

    def flex():
        string = '''
        %{
    #include<stdio.h>       //header files and declaration
    int v = 0, c = 0;
%}
%%
[aeiouAEIOU]    {v++;}      //regex and logic
[a-zA-Z]        {c++}
.               {}
%%
int yywrap(void){           //necessary
    return 1;
}
int main(){
    printf("Enter the Text");
    yylex();                                                        //important
    printf("\n No of vowels = %d \n No of consonents = %d",v,c);
    return 0;
}

int main logic to take input from file
int main(int argc, char** argv){
    if (argc > 1){
        FILE *file;
        file = fopen(argv[1],"r");
        if(!file){
            printf("Could not open file");
            exit(1);
        }
        yyin = file;
    }
    yylex()
    //printf statements
}

Logic for odd even
[0-9]+      {
                i = atoi(yytext);
                if(i%2==0)
                    printf("Even");
                else
                    printf("Odd");
            }

Command to run flex

flex filename.l
gcc lex.yy.c -o filename.exe
filename.exe


        '''
        print(string)

    def OP():
        string = '''
        import numpy as np
def stringcheck():
    a = list(input("Enter the operators and non terminals used --> "))
    a.append('$')
    print(a)
    l = list("abcdefghijklmnopqrstuvwxyz")
    o = list('(/*%+-)')
    p = list('(/*%+-)')
    n = np.empty([len(a) + 1, len(a) + 1], dtype=str, order="C")
    for j in range(1, len(a) + 1):
        n[0][j] = a[j - 1]
        n[j][0] = a[j - 1]
    for i in range(1, len(a) + 1):
        for j in range(1, len(a) + 1):
            if ((n[i][0] in l) and (n[0][j] in l)):
                n[i][j] = ""
            elif ((n[i][0] in l)):
                n[i][j] = ">"
            elif ((n[i][0] in o) and (n[0][j] in o)):
                if (o.index(n[i][0]) <= o.index(n[0][j])):
                    n[i][j] = ">"
                else:
                    n[i][j] = "<"
            elif((n[i][0] in o) and n[0][j] in l):
                n[i][j] = "<"
            elif (n[i][0] == "$" and n[0][j] != "$"):
                n[i][j] = "<"
            elif (n[0][j] == "$" and n[i][0] != "$"):
                n[i][j] = ">"
            else:
                break
    print("The Operator Precedence RelationalTable\n=============================================")
    print(n)
    i = list(input("Enter the string want to be checked --> "))
    i.append("$")
    s = [None] * len(i)
    q = 0
    s.insert(q, "$")
    x = [row[0] for row in n]
    y = list(n[0])
    h = 0
    while (s[0] != s[1]):
        if ((i[len(i) - 2] in p)):
            break
        elif ((s[q] in x) and (i[h] in y)):
            if (n[x.index(s[q])][y.index(i[h])] == "<"):
                q += 1
                s.insert(q, i[h])
                h += 1
            elif (n[x.index(s[q])][y.index(i[h])] == ">"):
                s.pop(q)
                q -= 1
            elif ((n[x.index(s[q])][y.index(i[h])] == '') and ((s[q] == "$") and (i[h] == "$"))):
                s[1] = s[0]
        else:
            break
    if (s[0] != s[1]):
        return False
    else:
        return True

def grammarcheck(i):
    print("Enter the",
    str(i + 1) + "th grammar(production) For null production please enter any special symbol or whitespace --> ")
    b = list(input().split("->"))
    f = list("abcdefghijklmnopqrstuvwxyz")
    if (b[0] == " " or b[0] == "" or b[0] in f or len(b) == 1):
        return False
    else:
        b.pop(0)
        b = list(b[0])
        s = list("ABCDEFGHIJKLMNOPQRSTUVWXYZ")
        o = list("(abcdefghijklmnopqrstuvwxyz^/*+-|)")
        sp = ['!', '@', '#', '$', '?', '~', '`', ',', ';', ':', '"', '=', '_', '&', "'", "", " "]
        for i in range(0, len(b), 2):
            if (b[i] == " "):
                g = False
            elif (b[i] in sp):
                g = False
                break
            elif (b[len(b) - 1] in o and ((b[0] == "(" and b[len(b) - 1] == ")") or (b.count("(") == b.count(")")))):
                g = True
            elif (b[i] in f):
                g = True
            elif (b[len(b) - 1] in o):
                g = False
            elif ((i == len(b) - 1) and (b[i] in s)):
                g = True
            elif ((i == len(b) - 1) and (b[i] not in s) and (b[i] in o) and b[i - 1] in o):
                g = True
            elif ((b[i] in s) and (b[i + 1] in o)):
                g = True
            elif ((b[i] in s) and (b[i + 1] in s)):
                g = False
                break
            else:
                g = False
                break
        if (g == True):
            return True
        else:
            return False

c = int(input("Enter the number of productions = "))
for i in range(c):
    if (grammarcheck(i)):
        t = True
    else:
        t = False
        break
if t:
    if (stringcheck()):
        print("String is accepted")
    else:
        print("String is not accepted")
else:
    print("Grammar is not accepted ")

    
    #A->a
    #A->A+A
    #a+
    #a+a
        '''
        print(string)

    def DSP1():
        string = '''
        import java.util.*;

public class DSP1 {
    public static int evaluateOperand(String operand, Map<String, Integer> symtab) throws IllegalArgumentException {
        if (symtab.containsKey(operand)) {
            return symtab.get(operand);
        } else if (operand.matches("\\d+")) {
            return Integer.parseInt(operand);
        } else {
            throw new IllegalArgumentException("Invalid operand: " + operand);
        }
    }

    public static void main(String[] args) {
        String assemblyCode = "START 10\n(LOOP) MOV A, #5\nMOV B, #7\nADD A, B\nJMP LOOP\nEND";
        System.out.println("ASSEMBLY CODE: ");
        System.out.println(assemblyCode + "\n");
        HashMap<String, Integer> symtab = new HashMap<>();
        HashMap<String, HashMap<String, Object>> littab = new HashMap<>();
        ArrayList<Integer> pooltab = new ArrayList<>(Arrays.asList(0));
        Scanner inputScanner = new Scanner(System.in);
        HashMap<String, String> opcodeTable = new HashMap<>();
        while (true) {
            System.out.print("Enter an opcode mnemonic (or 'done' to finish): ");
            String opcode = inputScanner.nextLine();
            if (opcode.equals("done")) {
                break;
            }
            System.out.print("Enter the corresponding opcode value: ");
            String value = inputScanner.nextLine();
            opcodeTable.put(opcode, value);
        }
        Integer locationCounter = null;
        String[] lines = assemblyCode.split("\n");
        System.out.println("\nOPTAB:");
        for (String opcode : opcodeTable.keySet()) {
            System.out.println(opcode + " " + opcodeTable.get(opcode));
        }
        System.out.println("\nIntermediate code");
        for (int i = 0; i < lines.length; i++) {
            String line = lines[i].split("//")[0].trim();
            if (line.isEmpty()) {
                continue;
            }
            if (line.startsWith("(")) {
                String symbol = line.substring(1, line.indexOf(")"));
                symtab.put(symbol, locationCounter);
                continue;
            }
            if (line.startsWith("\"") && line.endsWith("\"")) {
                String literal = line.substring(1, line.length() - 1);
                if (!littab.containsKey(literal)) {
                    HashMap<String, Object> literalMap = new HashMap<>();
                    literalMap.put("value", literal);
                    literalMap.put("address",
                            null);
                    littab.put(literal, literalMap);
                }
                continue;
            }
            String[] parts = line.split("\\s+");
            String opcode = parts[0];
            String operand = parts.length == 1 ? null : String.join(" ", Arrays.copyOfRange(parts, 1, parts.length));
            if (opcode.equals("START")) {
                locationCounter = Integer.parseInt(operand);
            } else if (opcode.equals("ORIGIN")) {
                locationCounter = evaluateOperand(operand, symtab);
            } else if (opcode.equals("LTORG")) {
                pooltab.add(littab.size());
                for (HashMap<String, Object> literalMap : littab.values()) {
                    if (literalMap.get("address") == null) {
                        literalMap.put("address", locationCounter);
                        locationCounter++;
                    }
                }
            } else {
                locationCounter++;
            }
            System.out.printf("%d\t%s\t%s\t%d\n", i + 1, opcode, operand, locationCounter);
        }
        System.out.println("\nSymbol Table: " + symtab);
        System.out.println("Literal Table: " + littab);
        System.out.println("Pool Table: " + pooltab);
    }
}

        '''
        print(string)

    def P2():
        string = '''
        import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;

public class Pass2 {
    public static void main(String[] Args) throws IOException {
        BufferedReader b1 = new BufferedReader(new FileReader("intermediate.txt"));
        BufferedReader b2 = new BufferedReader(new FileReader("symtab.txt"));
        BufferedReader b3 = new BufferedReader(new FileReader("littab.txt"));
        FileWriter f1 = new FileWriter("Pass2.txt");
        HashMap<Integer, String> symSymbol = new HashMap<Integer, String>();
        HashMap<Integer, String> litSymbol = new HashMap<Integer, String>();
        HashMap<Integer, String> litAddr = new HashMap<Integer, String>();
        String s;
        int symtabPointer = 1, littabPointer = 1, offset;
        while ((s = b2.readLine()) != null) {
            String word[] = s.split("\t\t\t");
            if (word.length < 2)
                continue;
            symSymbol.put(symtabPointer++, word[1]);
        }
        while ((s = b3.readLine()) != null) {
            String word[] = s.split("\t\t");
            if (word.length >= 2) {
                litSymbol.put(littabPointer, word[0]);
                litAddr.put(littabPointer++, word[1]);
            }
        }
        while ((s = b1.readLine()) != null) {
            if (s.substring(1, 6).compareToIgnoreCase("IS,00") == 0) {
                f1.write("+ 00 0 000\n");
            } else if (s.substring(1, 3).compareToIgnoreCase("IS") == 0) {
                f1.write("+ " + s.substring(4, 6) + " ");
                if (s.charAt(9) == ')') {
                    f1.write(s.charAt(8) + " ");
                    offset = 3;
                } else {
                    f1.write("0 ");
                    offset = 0;
                }
                if (s.charAt(8 + offset) == 'S')
                    f1.write(symSymbol.get(Integer.parseInt(s.substring(10 + offset, s.length() - 1))) + "\n");
                else
                    f1.write(litAddr.get(Integer.parseInt(s.substring(10 + offset, s.length() -
                            1))) + "\n");
            } else if (s.substring(1, 6).compareToIgnoreCase("DL,01") == 0) {
                String s1 = s.substring(10, s.length() - 1), s2 = "";
                for (int i = 0; i < 3 - s1.length(); i++)
                    s2 += "0";
                s2 += s1;
                f1.write("+ 00 0 " + s2 + "\n");
            } else {
                f1.write("\n");
            }
        }
        f1.close();
        b1.close();
        b2.close();
        b3.close();
    }
}

Intermediate.txt
(AD,01)(C,200)
(IS,04)(1)(L,1)
(IS,05)(1)(S,1)
(IS,04)(1)(S,1)
(IS,04)(3)(S,3)
(IS,01)(3)(L,2)
(IS,07)(6)(S,4)
(DL,01)(C,5)
(DL,01)(C,1)
(IS,02)(1)(L,3)
(IS,07)(1)(S,5)
(IS,00)
(AD,03)(S,2)+2
(IS,03)(3)(S,3)
(AD,03)(S,6)+1
(DL,02)(C,1)
(DL,02)(C,1)
(AD,02)
(DL,01)(C,1)
Littab.txt
5 206
1 207
1 213


Symtab.txt
A 211 1
LOOP 202 1
B 212 1
NEXT 208 1
BACK 202 1
LAST 210 1

        '''
        print(string)

    def macro():
        string = '''
        Macro.txt
#include<stdio.h>
#include<conio.h>
MACRO
&LAB INCR &ARG1 , &ARG2 , &ARG3
&LAB ADD AREG, &ARG1
	ADD AREG, &ARG2
	ADD AREG, &ARG3
MEND


MacroPass.py
mntc = 1
mdtc = 1
ala_counter = 1
ala_set = set()
ala = {}
mnt = []
mdt = {}
mystring = ''
file = open('macro.txt')
list_program = list(file)
file.close()
file = open('macro.txt', 'r+')
program = file.read()
words = program.split()
for i in range(len(words)):
       if words[i] == "MACRO":
           index = i
           for i in range(index + 1, len(words)):
               if words[i].startswith("&") and words[i] not in ala_set:
                   ala_set.add(words[i])
                   ala[ala_counter] = words[i]
                   ala_counter += 1
for i in range(len(list_program)):
   if list_program[i] == "MACRO\n":
       mnt.append(mntc)
       line_split = list_program[i+1].split()
       mnt.append(line_split[1])
       mnt.append(mdtc)
       mntc+=1
       macro_define_index = i + 2
       mdt[mdtc] = list_program[i+1]
       mdtc += 1
       for j in range(macro_define_index, len(list_program)):
           line_split = list_program[j].split()
           for k in range(len(line_split)):
               if line_split[k] in ala_set:
                   for index in range(1, len(ala_set) + 1):
                       value = ala.get(index)
                       if value == line_split[k]:
                           temp = index
                           break
                   line_split[k] = '#' + str(temp)
           mdt[mdtc] = line_split
           mdtc += 1
print("ALA\nIndex\tArgument")
for i in range(1, len(ala)+1):
   print(i, "\t", ala.get(i))
print("\n\nMNT\nIndex\tMacro Name MDT Index")
for i in range (len(mnt)):
   print(mnt[i],"\t ", end="")
print("\n\nMDT\nIndex\tCard")
for i in range (1, len(mdt)+1):
   print(i,"\t", mdt.get(i))
        '''
        print(string)

    def yacc():
        string = '''
        calci.l file
%{
	#include "y.tab.h"
	#include<math.h>
	extern double vbltable[26];
%}

%%
[0-9]+      {yylval.dval=atof(yytext); return NUMBER;  }
[\t];
[a-z]       {yylval.vblno=yytext[0] - 'a'; return NAME;}
"$"         { return 0;}
\n  |
.           return yytext[0];
%%

int yywrap(void) {
  	return 0;
}

int main(void) {
	yyparse();
	return 0;
}

int yyerror(void) {
	printf("error");
	exit(1);
}


Calci.y file
%{
double vbltable[26];
int yylex(void);
%}
%union{
 double dval;
 int vblno;
}
%token <vblno> NAME
%token <dval> NUMBER
%left '-' '+'
%left '*' '/'
%nonassoc UMINUS
%type <dval> expression
%%
statement_list: statement '\n'
                            |  statement_list statement '\n'
                            ;
statement: NAME '=' expression                {vbltable[$1] = $3;}
                       | expression                 {printf("=%g\n",$1);  }
                       ;
expression: expression '+' expression              { $$=$1 + $3;}
                   | expression '-' expression             { $$=$1 - $3;}
                     | expression '*' expression                { $$=$1 * $3;}
                    | expression '/' expression     {   if($3==0.0)
					yyerror("divide by zero");
					else
					 $$ = $1/$3;
				}
                          | '-' expression %prec UMINUS { $$ = -$2;}
                          | '(' expression ')'  {$$ =$2;}
                          | NUMBER
                          | NAME {$$ = vbltable[$1];  }
                         ;
%%


Icg.l file
%{
#include"y.tab.h"
%}
%%
[a-zA-Z]+ 	{strcpy(yylval.str,yytext);   return Var;}
[0-9]+		{strcpy(yylval.str,yytext);   return Num;}
\n		{return 0;}
[ \t]		{}
.		{return yytext[0];}
%%
int yywrap()
{
return 1;
}


Icg.y file
%{
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
char * createT();		// Declaration for creating the temporary variables
int tempcount=0;		// Global variable to track the number of temporary variables
%}
%union	{	char str[30];	}
		// Redefining the datatype of yylval using union declaration, which is int by default
%left '+' 
%left '-'
%left '*'
%left '/'
%token <str> Var	// Defining the datatype of Tokens as str 
%token <str> Num
%type  <str> s		// Defining the datatypes of Non-Terminals
%type  <str> exp
%%
s	:	Var '=' exp	{printf("\n%s=%s\n",$1,$3);}
exp	:	'(' exp ')' 	{strcpy($$,$2);}
 	|	exp '+' exp	{strcpy($$,createT()); printf("\n%s=%s+%s",$$,$1,$3);} 
	|	exp '-' exp	{strcpy($$,createT()); printf("\n%s=%s-%s",$$,$1,$3);}
	|	exp '*' exp	{strcpy($$,createT()); printf("\n%s=%s*%s",$$,$1,$3);}
	|	exp '/' exp	{strcpy($$,createT()); printf("\n%s=%s/%s",$$,$1,$3);}
	|	Num  		{strcpy($$,$1);}
	|	Var		{strcpy($$,$1);}
;
%%
char * createT()
{
	char snum[30],*ptr;			// Declaring the string array and pointer variable
	sprintf(snum,"t%d",tempcount);	// Returning a formatted String
	ptr=snum;			// Intializing the pointer with formatted string address
	tempcount++;				// Temporary count
	return ptr;				// Returning the pointer
}
int main()
{	
yyparse(); 	
return 0;	
}
int yyerror(char *err)
{	
printf("\nInvlaid");
	exit(0);
}


Var.l file
%{
    #include "y.tab.h"
%}
%%
[a-zA-Z_][a-zA-Z_0-9]* return letter;
[0-9]                       return digit;
.                      return yytext[0];
\n                     return 0;
%%
int yywrap()
{
return 1;
}



Var.y file
%{
    #include<stdio.h>
    int valid=1;
%}
%token digit letter
%%
start : letter s
s :     letter s
      | digit s
      |
      ;
%%
int yyerror()
{
    printf("\nIts not a identifier!\n");
    valid=0;
    return 0;
}
int main()
{
    printf("\nEnter a name to tested for identifier ");
    yyparse();
    if(valid)
    {
        printf("\nIt is a identifier!\n");
    }
}

        '''
        print(string)

    def commands():
        string = '''
        flex filename.l
        bison filename.y
        bison -dy filename.y
        gcc lex.yy.c y.tab.c -o filename.exe
        filename.exe
        '''
        print(string)

    def ICG():
        string = '''
        Lex File
        %{
            #include"y.tab.h"
            extern char yyval;
        %}
        %%
        [0-9]+ {yylval.symbol=(char)(yytext[0]);
                return NUMBER;}
        [a-z]  {yylval.symbol=(char)(yytext[0]);
                return LETTER;}
        .       {retun yytext[0];}
        \n      {return 0;}
        %%

        Yacc File
        %{
            #include<stdio.h>
            #include"y.tab.h"
            char addtotable(char,char, char);
            int index1 = 0;
            char temp = 'A'-1;

            struct expr{
                char operand1;
                char operand2;
                char operator;
                char result;
            };
        %}
        %union{
            char symbol;
        }
        %left '+' '-'
        %left '/' '*'
        %token <symbol> LETTER NUMBER
        %type <symbol> exp
        %%
        statement:LETTER'=' exp ';' {addtotable((char)$1,(char)$3,'=');};
        exp:exp '+' exp {$$ = addtotable((char)$1,(char)$3,'+');}
            |exp '-' exp {$$ = addtotable((char)$1,(char)$3,'-');}
            |exp '/' exp {$$ = addtotable((char)$1,(char)$3,'/');}
            |exp '*' exp {$$ = addtotable((char)$1,(char)$3,'*');}
            |NUMBER {$$ = (char)$1;}
            |LETTER {(char)$1;};
        %%
        struct expr arr[20];

        void yyerror(char *s){
            printf("Error: %s",s);
        }

        char addtotable(char a, char b, char o){
            temp++;
            arr[index1].operand1 = a;
            arr[index1].operand2 = b;
            arr[index1].operator = o;
            arr[index1].result = temp;
            index1++;
            return temp;
        }
        void threeAdd(){
            int i=0;
            char temp='A';
            while(i<index1){
                printf("%c :=\t",arr[i].result);
                printf("%c\t%c\t%c\n",arr[i].operand1,arr[i].operator,arr[i].operand2);
                i++;
                temp++; 
            }
        }
        void fouradd(){
            int i=0;
            char temp='A';
            while(i<index1){
                printf("%c \t",arr[i].operator);
                printf("%c\t%c\t%c\n",arr[i].operand1,arr[i].operand2,arr[i].result);
                i++;
                temp++;
            }
        }
        int find(char l){
            int i;
            for(i=0;i<index1;i++)
                if(arr[i].result==l)    break;
            return i;
        }
        void triple(){
            int i=0;
            char temp='A';
            while(i<index1){
                printf("%c\t",arr[i].operator);
                if(!isupper(arr[i].operand1))
                    printf("%c\t",arr[i].operand1);
                else{
                    printf("pointer");
                    printf("%d\t",arr[find(arr[i].operand1)].result);
                }
                if(!isupper(arr[i].operand2))
                    printf("%c\t",arr[i].operand2);
                else{
                    printf("pointer");
                    printf("%d\t",arr[find(arr[i].operand2)].result);
                }
                i++;
                temp++;
                printf("\n")
            }        
        }
        int yywrap(){
            return 1;
        }
        int main(){
            printf("Enter the expression:\n");
            yyparse();
            printf("Three Address Code:\n");
            threeAdd();
            printf("Four Address Code:\n");
            fouradd();
            printf("Triple Address Code:\n");
            triple();
            return 0;
            }
        '''

        print(string)

    def ICG2():
        string = '''
       LEX:

%{
#include"y.tab.h"
%}
%%
[a-zA-Z]+ 	{strcpy(yylval.str,yytext);   return Var;}
[0-9]+		{strcpy(yylval.str,yytext);   return Num;}
\n		{return 0;}
[ \t]		{}
.		{return yytext[0];}
%%
int yywrap() {
return 1;
}


Yacc:

%{
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
char * createT();
int tempcount=0;
%}
%union {char str[30];}
%left '+' 
%left '-'
%left '*'
%left '/'
%token <str> Var
%token <str> Num
%type  <str> s
%type  <str> exp
%%
s	:	Var '=' exp	{printf("\n%s=%s\n",$1,$3);}
exp	:	'(' exp ')' 	{strcpy($$,$2);}
 	|	exp '+' exp	{strcpy($$,createT()); printf("\n%s=%s+%s",$$,$1,$3);} 
	|	exp '-' exp	{strcpy($$,createT()); printf("\n%s=%s-%s",$$,$1,$3);}
	|	exp '*' exp	{strcpy($$,createT()); printf("\n%s=%s*%s",$$,$1,$3);}
	|	exp '/' exp	{strcpy($$,createT()); printf("\n%s=%s/%s",$$,$1,$3);}
	|	Num  		{strcpy($$,$1);}
	|	Var		{strcpy($$,$1);}
;
%%
char * createT() {
	char snum[30],*ptr;			
	sprintf(snum,"t%d",tempcount);	
	ptr=snum;			
	tempcount++;
	return ptr;				
}
int main() {	
yyparse(); 	
return 0;	
}
int yyerror(char *err) {	
printf("\nInvlaid");
	exit(0);
}


how to run:
flex icg.l
bison icg.y
bison -dy icg.y
gcc lex.yy.c -o icg.exe
icg.exe
ans = (a+b)+(c*d)
        '''
        print(string)

    def generatePT():
        string = '''
        # Function to generate the LL(1) parsing table
def generate_table(grammar, start_symbol, first_sets, follow_sets):
    # Initialize the parsing table
    table = {}
    for nonterminal in grammar:
        for production in grammar[nonterminal]:
            # Compute the FIRST set of the production
            first_set = set()
            for symbol in production:
                if symbol in first_sets:
                    first_set |= first_sets[symbol]
                    if 'epsilon' not in first_sets[symbol]:
                        break
                else:
                    first_set.add(symbol)
                    break
            else:
                first_set.add('epsilon')
            # Add entries to the parsing table based on the FIRST set
            for terminal in first_set:
                if terminal != 'epsilon':
                    table[(nonterminal, terminal)] = production
            # Add entries to the parsing table based on the FOLLOW set
            if 'epsilon' in first_set:
                follow_set = follow_sets[nonterminal]
                for terminal in follow_set:
                    table[(nonterminal, terminal)] = production
                if '$' in follow_set:
                    table[(nonterminal, '$')] = production
    # Return the LL(1) parsing table
    return table

# Example usage of the generate_table function
# Define the grammar as a dictionary of nonterminals and productions
grammar = {
    'S': ['A', 'b'],
    'A': ['a', 'B'],
    'B': ['b', 'epsilon']
}
# Define the start symbol of the grammar
start_symbol = 'S'
# Get user input for the FIRST and FOLLOW sets of the grammar
first_sets = {}
follow_sets = {}
for nonterminal in grammar:
    first = input("Enter FIRST set for " + nonterminal + ": ")
    first_sets[nonterminal] = set(first.split())
    follow = input("Enter FOLLOW set for " + nonterminal + ": ")
    follow_sets[nonterminal] = set(follow.split())
# Generate the LL(1) parsing table
table = generate_table(grammar, start_symbol, first_sets, follow_sets)
# Print the LL(1) parsing table
print("LL(1) Parsing Table:")
print("{:<10}".format(""), end="")
for terminal in first_sets[start_symbol] | {'$'}:
    print("{:<10}".format(terminal), end="")
print()
for nonterminal in grammar:
    print("{:<10}".format(nonterminal), end="")
    for terminal in first_sets[start_symbol] | {'$'}:
        if (nonterminal, terminal) in table:
            production = " ".join(table[(nonterminal, terminal)])
            print("{:<10}".format(production), end="")
        else:
            print("{:<10}".format(""), end="")
    print()


How to execute:
Enter FIRST set for S: a b
Enter FOLLOW set for S: $
Enter FIRST set for A: a
Enter FOLLOW set for A: b $
Enter FIRST set for B: b epsilon
Enter FOLLOW set for B: a $

Output:
LL(1) Parsing Table:
          a         b         $
S         A         b
A         a         B         epsilon
B                   b         epsilon
        '''
        print(string)
    
    def P1macro():
        string = '''
        mntc = 1
mdtc = 1
ala_counter = 1
ala_set = set()
ala = {}
mnt = []
mdt = {}
mystring = ''
file = open('macro.txt')
list_program = list(file)
file.close()
file = open('macro.txt', 'r+')
program = file.read()
words = program.split()
for i in range(len(words)):
    if words[i] == "MACRO":
        index = i
        # ALA
        for i in range(index + 1, len(words)):
            if words[i].startswith("&") and words[i] not in ala_set:
                ala_set.add(words[i])
                ala[ala_counter] = words[i]
                ala_counter+=1
                
for i in range(len(list_program)):
    if list_program[i] == "MACRO\n":
        mnt.append(mntc)
        line_split = list_program[i+1].split()
        mnt.append(line_split[1])
        mnt.append(mdtc)
        mntc+=1
        macro_define_index = i + 2
        mdt[mdtc] = list_program[i+1]
        mdtc+=1
        for j in range(macro_define_index, len(list_program)):
            line_split = list_program[j].split()
            for k in range(len(line_split)):
                if line_split[k] in ala_set:
                    for index in range(1, len(ala_set)+1):
                          value = ala.get(index)
                          if value == line_split[k]:
                              temp = index
                              break
                    line_split[k] = '#' + str(temp)
            mdt[mdtc] = line_split
            mdtc+=1
            
print("ALA\nIndex\tArgument")
for i in range(1, len(ala)+1):
    print(i, "\t", ala.get(i))
    
print("\n\nMNT\nIndex\tMacro Name  MDT Index")
for i in range (len(mnt)):
    print(mnt[i],"\t   ", end="")
    
print("\n\nMDT\nIndex\tCard")
for i in range (1, len(mdt)+1):
    print(i,"\t", mdt.get(i))


macro.txt:

START
    MACRO
    INCR1 &A, &B
    ADD &A, 1
    ADD &B, 1
    MEND
    CALL INCR1, &FIRST, &SECOND
    END
        '''
        print(string)
    
    def P2macro():
        string = '''
        MDT = []  # Macro Definition Table
MNT = {}  # Macro Name Table
ALA = {}  # Argument List Array

# Read MDT, MNT, and ALA from files generated in pass-1
with open('MDT.txt', 'r') as f:
    for line in f:
        MDT.append(line.strip().split())
        
with open('MNT.txt', 'r') as f:
    for line in f:
        name, index = line.strip().split()
        MNT[name] = int(index)
        
with open('ALA.txt', 'r') as f:
    for line in f:
        index, arg = line.strip().split()
        ALA[int(index)] = arg

# Read input file
with open('input.txt', 'r') as f:
    for line in f:
        line = line.strip()
        if line in MNT:  # Macro call
            mdt_index = MNT[line]
            ala_index = 1
            for i in range(mdt_index, len(MDT)):
                card = MDT[i]
                if card[0] == 'MEND':
                    break
                for j in range(1, len(card)):
                    if card[j][0] == '&':
                        card[j] = ALA[int(card[j][1:])]
                    else:
                        card[j] = card[j]
                print('\t'.join(card))
        else:  # Non-macro instruction
            print(line)
        '''
        print(string)

    def main():
        string = '''
        lexical()
        flex()
        ff()
        generatePT()
        PP()
        OP()
        yacc()
        ICG()
        ICG2()
        commands()
        DSP1()
        P2()
        macro()
        P1macro()
        P2macro()
        '''
        print(string)